// -*- C++ -*-
//
// Copyright (C) 1998, 1999, 2000, 2002  Los Alamos National Laboratory,
// Copyright (C) 1998, 1999, 2000, 2002  CodeSourcery, LLC
//
// This file is part of FreePOOMA.
//
// FreePOOMA is free software; you can redistribute it and/or modify it
// under the terms of the Expat license.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Expat
// license for more details.
//
// You should have received a copy of the Expat license along with
// FreePOOMA; see the file LICENSE.
//

//-----------------------------------------------------------------------------
// Global TagGenerator
//-----------------------------------------------------------------------------

// include files

#include "Pooma/Pooma.h"
#include "Tulip/Messaging.h"

#include "Tulip/CollectFromContexts.h"
#include "Tulip/ReduceOverContexts.h"
#include "Tulip/RemoteProxy.h"
#include "Tulip/PatchSizeSyncer.h"
#include "Tulip/SendReceive.h"


//-----------------------------------------------------------------------------
// Tag generator creates a set of tags for global use in r2.  There is a
// separate tag number for each context we communicate with.
//-----------------------------------------------------------------------------

TagGenerator tagGenerator_g;

namespace Pooma {

//-----------------------------------------------------------------------------
// expectedMessages
//-----------------------------------------------------------------------------

int expectedMessages_g = 0;

void initializeCheetahHelpers(int contexts)
{
  tagGenerator_g     = TagGenerator(contexts);
  expectedMessages_g = 0;
}

void finalizeCheetahHelpers()
{
  PAssert(expectedMessages_g == 0);
}

int sendTag(int context)
{
  return tagGenerator_g.send(context);
}

int receiveTag(int context)
{
  return tagGenerator_g.receive(context);
}

} // namespace Pooma

// ACL:rcsinfo
// ----------------------------------------------------------------------
// $RCSfile: Messaging.cmpl.cpp,v $   $Author: richi $
// $Revision: 1.11 $   $Date: 2004/12/14 10:15:52 $
// ----------------------------------------------------------------------
// ACL:rcsinfo
